from git.exc import InvalidGitRepositoryError
from git.repo.base import Repo
from praise.praise import praise
from subprocess import PIPE
from subprocess import Popen
import os
import sys
import click

@click.command()
@click.argument('filename')
def praise_command(filename=None):
    try:
        repo = Repo(path=os.getcwd(), search_parent_directories=True)
    except InvalidGitRepositoryError:
        print('Not a git repository')
        return
    output = praise(filename, repo)
    terminal_height, terminal_width = os.popen(
        'stty size', 'r').read().split()
    lines = output.split('\n')
    if len(lines) > int(terminal_height):
        click.echo_via_pager(output)
    else:
        click.echo(output)
